import React from 'react';
import ToolTip from 'react-portal-tooltip'

import LoginForm from './login_form'
import GistDataStore from '../lib/data_store_gist';
import LocalCredStore from '../lib/data_store_cred';

require("../style/authbar.less")

// var EventEmitter = require('events').EventEmitter
// import {EventEmitter} from 'events'

// console.log(EventEmitter)

export default class AuthBar extends React.Component {
  constructor(props){
    super(props)
    this.state = {show_login_form: false}
    this.toggleLoginForm = this.toggleLoginForm.bind(this)
    this.loginFormSubmit = this.loginFormSubmit.bind(this)
  }
  toggleLoginForm(e){
    if (e) { e.preventDefault() }
    //skip the form if we have their info
    // if (!this.state.show_login_form && LocalCredStore.get_cred()){
    //   this.props.loginFormSubmit( LocalCredStore.get_cred() )
    //   return
    // }
    this.setState({show_login_form: !this.state.show_login_form})
  }
  loginFormSubmit(d){
    this.props.loginFormSubmit(d)
    this.setState({show_login_form: false})

  }
  render(){
    // let barStyle = {  transition: "all 0.5s ease", height: this.state.show_login_form ? 150: 20}
    // let cn = this.state.show_login_form ? "authbar has_form": "authbar"
    // might want something more robust?
    let is_logged_in = this.props.user_data && this.props.user_data.username
    let submit_work_button = this.props.submitWorkClicked ? <a href="#" onClick={(e)=>{e.preventDefault(); this.props.submitWorkClicked() } }>Submit</a> : null
    // return (<div className={cn} style={barStyle}>
    return (<div className="authbar">
      <SaveControl {...this.props} {...this.state}/>
      <MetaInfo {...this.props} {...this.state}/>
      <div className="submit_control">{submit_work_button}</div>
      <UserInfo {...this.props} {...this.state} loginFormSubmit={this.loginFormSubmit} toggleLoginForm={this.toggleLoginForm}/>
    </div>)
  }
}

//       <MetaInfo {...this.props} {...this.state} />



class MetaInfo extends React.Component {
  render(){
    let is_logged_in = this.props.user_data && this.props.user_data.username
    let url = `https://gist.github.com/${this.props.user_version}`
    let icon_and_label = ''
    icon_and_label = is_logged_in && this.props.user_version === 0 ? <span>⌛️</span> : icon_and_label
    icon_and_label = is_logged_in && this.props.user_version ? <span><a target="_blank" href={url}>📓 Your Work</a></span> : icon_and_label
    icon_and_label = this.props.user_version===false ? `` : icon_and_label

    return <div>{icon_and_label}</div>
  }
}

class SaveControl extends React.Component {
  render(){
    // if (this.props.show_login_form) { return null}

    // TODO put this stuff in a tooltip
    // does it match our original, either gist or in page
    // let is_edited = this.props.gist_meta.edited_from_original ? <div>Your changes are saved locally (<a href="#" onClick={this.props.revert}>revert to original</a>)</div> : null
    // let is_clean = this.props.gist_meta.clean ? null : <div><a href="#" onClick={this.props.saveClicked}>Save to Github</a></div>

    // let is_clean = this.props.gist_meta.clean ?  <div>✅ </div>: <div>✳️</div>
    // `❇️`

    let icon_and_label = ''
    icon_and_label = this.props.has_saved ? <a href="#" onClick={this.props.saveClicked}><span>✅ </span>Saved!</a> : icon_and_label
    icon_and_label = this.props.is_dirty ? <a href="#" onClick={this.props.saveClicked}><span>✳️ </span>Save</a> : icon_and_label
    // icon_and_label = <a href="#"><span>✅ </span>Saved</a>

    // do you do anything to save ever?
    // icon = this.props.gist_meta.edited_from_original ? <a href="#"><span>✅ </span></a> :icon
    // did you do anything to save that hasn't been saved to github
    // icon = this.props.gist_meta.clean ?  icon : <a href="#"><span>✳️ </span>Save</a>

    // let is_edited = null
    // let is_clean = null
    return (<div className="save_control">
            {icon_and_label}
            </div>)
  }
}

class UserInfo extends React.Component {
  render(){
    // if we're not logged in, show this login link, unless we're showing form
    // if (!this.props.user_data.username && !this.props.show_login_form) {
    if (!this.props.user_data.username) {
      return (<div className="user_info">
                <a href="#" className="login_link" onClick={this.props.toggleLoginForm} ref={(element) => { this.login_link_el = element }}>
                  Github Login
                  </a>
                {this.login_link_el ? <ToolTip active={this.props.show_login_form}  parent={this.login_link_el} position="bottom" arrow="center">
                  <LoginForm submitted={this.props.loginFormSubmit} id={this.props.lab_id} />
                </ToolTip>: null}
              </div>)
    } else {
      // otherwise, show the logged in user
      return (<div className="user_info">
                <div>
                  <img className="avatar" src={this.props.user_data.avatar_url} />
                  <span className="username" >{this.props.user_data.username}</span>
                  <a href="#" className="logout_link" onClick={e=>{e.preventDefault();this.props.logOut() }}>(logout)</a>
                </div>

              </div>)
    }

  }
}
