import React from 'react';

export default class ConsoleView extends React.Component {
  constructor(props){
    super()
    // this.make_line = this.make_line.bind(this)
  }
  // Todo, a timeout before it shows a syntax error. have it fade in. clickable to go to location.
  componentWillReceiveProps(nextProps){ }
  componentDidUpdate(){
    if (this.refs.div){
      this.refs.div.scrollTop = this.refs.div.scrollHeight
    }
  }

  render(){
    return <div ref="div" className="console-view">
      {this.props.lines.map( (a_line, key) => a_line.type=='console-log' ? <OutputLogLine key={key} {...a_line} /> : <OutputErrorLine {...a_line} moveCursor={this.props.moveCursor} key={key} />)}
    </div>
  }
}



class OutputLogLine extends React.Component {
  render(){
    return (<div className={this.props.type+' output-line'} >
      {this.props.data.map( (d, i)=> <span key={i}>{d}</span> )}
      </div>)
  }
}

class OutputErrorLine extends React.Component {
  render(){
    if (this.props.type == 'console-fail'){
      let data = ["[object Object]"]
      return <OutputLogLine {...this.props} data={data} />
    }

    let type = this.props.type.split('-')[0]
    let line = type == 'syntax' ? this.props.line-1 : this.props.line
    let column = type == 'syntax' ? this.props.column-1 : this.props.column
    let markup = {__html: this.props.data.replace(/\n/g, '<br/>')}
    let goto_button = this.props.line === false ? '' : <span className="goto" onClick={ ()=>this.props.moveCursor(this.props.line-1, this.props.column-1) }>Go to line {this.props.line}</span>
    return (<div className={this.props.type+' output-line'} >
        <h3>{type} error {goto_button}</h3>
        <div className="content" dangerouslySetInnerHTML={markup} />
      </div>)
  }
}
