import React from 'react';
import {Controlled as CodeMirror} from 'react-codemirror2'


// require('codemirror/mode/javascript/javascript');

import 'codemirror/mode/javascript/javascript'
import 'codemirror/keymap/sublime'
import 'codemirror/mode/xml/xml'
import 'codemirror/mode/htmlmixed/htmlmixed'
import 'codemirror/mode/markdown/markdown'
import 'codemirror/addon/selection/active-line'
import 'codemirror/addon/edit/matchbrackets.js'
import 'codemirror/lib/codemirror.css'
import 'codemirror/theme/monokai.css'

import "codemirror/addon/fold/foldgutter.css"
import "codemirror/addon/dialog/dialog.css"
// import "codemirror/theme/monokai.css"

import "codemirror/addon/search/searchcursor.js"
import "codemirror/addon/search/search.js"
import "codemirror/addon/dialog/dialog.js"
import "codemirror/addon/comment/comment.js"
import "codemirror/addon/wrap/hardwrap.js"
import "codemirror/addon/fold/foldcode.js"
import "codemirror/addon/fold/brace-fold.js"

export default class Editor extends React.Component {
  constructor(props){
    super(props)
  }
  getMode(){
    if (this.props.ext =="html"){
      return "text/html"
    } else if (this.props.ext == "js"){
      return "javascript"
    } else if (this.props.ext == "md"){
      return "markdown"
    }
  }
  getCMoptions(){
    // let command_enter = (cm)=> console.log('z') //this.props.runPressed()
    let opt = {
      lineNumbers: this.props.lineNumbers,
      mode: this.getMode(),
      // mode: this.props.mode,
      styleActiveLine: true,
      matchBrackets: true,
      theme: this.props.theme, //"monokai",
      keyMap: this.props.keyMap,
      extraKeys:{
        'Cmd-Enter' : cm=> {this.props.runPressed()},
        'Shift-Enter' : cm=> {this.props.runPressed()},
      },
      htmlMode: true
    }
    return opt
  }
  // can't get declarative selection to work with react-codemirror2
  // so we use this outside in lab component
  editorDidMount(editor){
    this.cm = editor
    this.mark()
  }
  // todo, text marking would be nice
  mark(){
    let doc = this.cm.getDoc()
    let opt = {className:'mark'}
    // let mark = doc.markText({line:1, ch:1},{line:1, ch:4}, opt)
  }
  render(){
    return <CodeMirror
      ref="cm"
      value={this.props.value}
      onBeforeChange={this.props.onBeforeChange}
      editorDidMount={this.editorDidMount.bind(this)}
      options={this.getCMoptions()} />
  }
}

Editor.defaultProps = {
  theme: "default", // monokai
  keyMap: "sublime",
  lineNumbers: true,
}

// value={this.state.value}
// options={options}
// onBeforeChange={(editor, data, value) => {
//   this.setState({value});
// }}
// onChange={(editor, data, value) => {
// }}
