import React from 'react';


class Frame extends React.Component {
  constructor(props){
    super(props)
  }
  componentDidMount(){
    this.setContent(this.props.content)
  }
  componentWillReceiveProps( nextProps){
    // previously, we were calling set content here, under certain conditions
    // but using shouldComponentUpdate is way better
  }
  setContent(content){
    // react hasn't rendered the ref yet
    if (!this.refs["display_div"]) {return}
    // create a new iframe everytime, otherwise script leakage
    if (this.iframe) { this.iframe.remove() }
    this.iframe = document.createElement("iframe")
    // we'll need this tell our messages from this frame apart from others
    this.iframe.id = this.props.id
    // todo, we could use sandbox and not allow-same-origin, which would be more secure,
    // go back to passing an id into magicsandbox
    // https://developer.mozilla.org/en-US/docs/Web/HTML/Element/iframe
    // sandbox="allow-same-origin allow-scripts allow-popups allow-forms
    // this.iframe.sandbox="allow-scripts allow-popups allow-forms"
    // this.iframe.srcdoc = content

    // this.iframe.style.display = 'none'
    this.refs["display_div"].appendChild(this.iframe)
    let doc = this.iframe.contentWindow.document;
    doc.open();
    doc.write(content);
    doc.close();
  }
  shouldComponentUpdate(nextProps, nextState){
    if (!this.props.auto_update){ return false }
    if (nextProps.content == false){ return false }
    // is the content unchanged?
    if (nextProps.content == this.props.content){
      // console.log('dont update')
      return false
    } else {
      // console.log('do update')
      return true
    }
  }
  render(){
    // console.log('render')
    if (this.props.content != false){
      this.setContent(this.props.content)
    }
    return (<div className="frame" style={this.props.style}>
      <div ref="display_div" className="frame"></div>
    </div>)
  }
}

export default Frame

// http://jsfiddle.net/onury/ALHGP/
