import React from 'react';

// import DataStore from '../lib/data_store';

// import '../style/login_form.less'

export default class LoginForm extends React.Component {
  constructor(props){
    super(props)
    // need either token OR password
    this.state = {auth_type:'token', username:'', token:'', password: '', remember_me: true}
    this.handleInputChange = this.handleInputChange.bind(this)
  }
  handleInputChange(event){
    const target = event.target;
    const name = target.name.split(':')[0] // for radio
    // for checkbox
    const value = target.type === 'checkbox' ? target.checked : target.value;
    this.setState({
      [name]: value
    })
  }
  handleSubmit(event) {
    event.preventDefault()
    let username = this.state.username
    let remember_me = this.state.remember_me
    if (this.state.auth_type == 'token'){
      this.props.submitted({username, remember_me, token: this.state.token})
    } else {
      this.props.submitted({username, remember_me, password: this.state.password})
    }
  }
  render(){
    return (<div className="login_form">
      <h4>Login with Github</h4>
      <div>
        <label>
          <input type="radio" value="basic" name={`auth_type:${this.props.id}`} checked={this.state.auth_type == 'basic'} onChange={this.handleInputChange} />
          Basic Auth
        </label>
        <label>
          <input type="radio" value="token" name={`auth_type:${this.props.id}`} checked={this.state.auth_type == 'token'} onChange={this.handleInputChange} />
          Personal Token
        </label>
      </div>
      <form onSubmit={this.handleSubmit.bind(this)} >
      <label>Username<input type="text" name="username" value={this.state.username} onChange={this.handleInputChange} /></label>
      {this.state.auth_type == 'token' ? <label>Token<input type="text" name="token" value={this.state.token} onChange={this.handleInputChange} /></label> : <label>Password<input type="text" name="password" value={this.state.password} onChange={this.handleInputChange}/></label>}
      <label> Remember me
        <input
          name="remember_me"
          type="checkbox"
          checked={this.state.remember_me}
          onChange={this.handleInputChange} />
      </label>
      <button type="submit">Login</button>
      </form>
    </div>)
  }
}
