
import React from 'react';
import PropTypes from 'prop-types'
// console.log(React.PropTypes)

import Lab from './lab'
import {check_js_files_syntax, check_if_invalid_syntax} from '../lib/util'

export default class UncontrolledLab extends React.Component {
  constructor(props){
    super(props)
    this.state = {
      active_edit: this.props.initial_active_edit,
      // will be filled in with files
      files:false
    }
    // you might want to use this in dev, and for the authoring
    // if (this.props.disable_local_storage) { LocalCredStore.set_disabled() }
    this.onBeforeChange = this.onBeforeChange.bind(this)
    this.switchFile = this.switchFile.bind(this)
    this.addNewFile = this.addNewFile.bind(this)
  }
  componentDidMount(){
    this.loadInitialFileData()
  }
  loadInitialFileData(){
    let files = this.maybeAddIndexHTML(this.props.initial_files)
    // try the given filename (defaults to index.js)
    // if no file, fallback to index.html
    let active_edit = files[this.props.initial_active_edit] ? this.props.initial_active_edit : "index.html"
    this.setState({active_edit, files})
  }
  maybeAddIndexHTML(files){
    if (!files['index.html'] && this.props.index_html_default_content){
      files['index.html'] = {'content': this.props.index_html_default_content}
    }
    return files
  }
  onBeforeChange(editor, data, value){
    let files = this.state.files
    files[this.state.active_edit]["content"] = value
    let is_dirty = true
    this.setState({files, is_dirty})
  }
  switchFile(filename){
    let active_edit = filename
    this.setState({active_edit})
  }
  addNewFile(){
    let name = prompt("Name it:")
    if (!name){return}
    let files = this.state.files
    files[name] = {content:''}
    this.setState({files, active_edit:name})
  }
  render(){
    let addNewFile = this.props.show_new_file_button ? this.addNewFile : null
    let lab_or_loading = !this.state.files ? <div>LOADING</div> :
      <Lab {...this.state} id={this.props.id} {...this.props.lab_props} onBeforeChange={this.onBeforeChange} switchFile={this.switchFile} addNewFile={addNewFile}/>

    return <div className="gist_lab">
      {lab_or_loading}
    </div>
  }
}

const index_html_default_content = `<!DOCTYPE html><html><head></head><body><script type="text/javascript" src="index.js"></script></body></html>`

UncontrolledLab.defaultProps = {
  initial_active_edit: 'index.js',
  index_html_default_content,
  show_new_file_button: false
}
