
// XXX  we export an instance of this, i.e. as a singleton
class LCache {
  constructor(){
    // the string we use to store an index of all the items
    this.all_items_string = `lsc-ii`
    this.max_items = 10
    if (this.get_all_items()==null)
    {
      localStorage.setItem(this.all_items_string, JSON.stringify([]))
    }
  }
  get(key){
    let data = JSON.parse(localStorage.getItem(key))
    return data
  }
  // external interface, don't use this internally
  set(key, data){
    let all_items = this.get_all_items()
    if (all_items.length >this.max_items) {
      this.shift()
      all_items.shift()
    }
    all_items.push(key)
    try {
      localStorage.setItem(key, JSON.stringify(data))
    } catch (e) {
      console.log(`WARNING, OUT OF LOCAL STORAGE. TRYING TO DElETE OLD STUFF.`)
      this.shift()
      this.set(key, data)
    }
    localStorage.setItem(this.all_items_string, JSON.stringify(all_items))
  }
  del(key){
    localStorage.removeItem(key)
  }
  get_all_items(){
    return JSON.parse(localStorage.getItem(this.all_items_string))
  }
  shift(){
    let all_items = this.get_all_items()
    let key = all_items.shift()
    this.del(key)
    localStorage.setItem(this.all_items_string, all_items)
  }
  clear(){
    for (let item of this.get_all_items() ){
      this.del(item)
    }
  }
}
// XXX exporting an instance XXX
const LocalCache = new LCache()
/// XXX hubkit relies on this!
LocalCache.max = 10000000
// length?
window.LocalCache = LocalCache
export default LocalCache
