let Babel = require("babel-standalone")

export function check_js_files_syntax(files){
  // console.log(files)
  for (let [filename, file] of Object.entries(files) ) {
    if (filename.endsWith('.js')) {
      let err = check_if_invalid_syntax(file['content'])
      // "pos" "loc" "codeFrame", and filename
      if (err) { return {err, filename}}
    }
  }
  return false
}

// helper, to check for errors
export function check_if_invalid_syntax(file){
  try {
    let output = Babel.transform(file, {  })
    return false
  } catch (e) {
    return e
  }
}


export function parse_error_loc(stack){
  let top = stack.split('\n')[1]
  top = top.split('>')[top.split('>').length-1]
  let [z,line, col] = top.split(':')
  // because of our try catch
  line -=2
  let pos = {line, col}
  return pos
}

//  hacky but whatevs
// https://stackoverflow.com/a/1248916/83859
export function deentitize(ret) {
    ret = ret.replace(/&gt;/g, '>');
    ret = ret.replace(/&lt;/g, '<');
    ret = ret.replace(/&quot;/g, '"');
    ret = ret.replace(/&apos;/g, "'");
    ret = ret.replace(/&amp;/g, '&');
    return ret;
}
