// For our production build, without including big external deps

var path = require('path')
var webpack = require('webpack')

module.exports = {
    entry: './src/index.js',
    output: {
      filename: 'js-lesson.bundle.min.js',
      libraryTarget: 'umd',
      library: 'JSLesson',
      path: path.resolve(__dirname, '..', 'dist/'),
    },

    module: {
      rules: [
        {
          test: /\.js?$/,
          use: {
            loader: 'babel-loader',
            options: {
                presets: ['react', 'es2015']
            }
          },
          exclude: /node_modules/,
        },
        {
          test: /\.css$/,
          use: [ 'style-loader', 'css-loader']
        },
        {
          test: /\.less$/,
          use: [ 'style-loader', 'css-loader', 'less-loader']
        },
        {
          test: /\.json$/,
          use: [ 'json-loader']
        },
      ],
    },
  }
